package afwhs.a0001

import jp.hishidama.afwhs._

object Sample1WordCount3 {

  implicit def implicitLineModel(in: Source[LineModel]) = new {
    def splitText() = in.cogroup("split", "", Result[WordCountModel]("out"))(
      Sample1WordCount3.splitText)
  }

  def splitText(s1: Seq[LineModel], r1: Result[WordCountModel]): Unit = {
    s1.foreach {
      _.text.split("[ \t]+").foreach { w => r1.add(WordCountModel(w, 1)) }
    }
  }

  implicit def implicitWordCountModel(in: Source[WordCountModel]) = new {
    def sumByWord() = in.cogroup("sum", "word", Result[WordCountModel]("out"))(
      Sample1WordCount3.sumByWord)
  }

  def sumByWord(s1: Seq[WordCountModel], r1: Result[WordCountModel]): Unit = {
    r1.add(WordCountModel(s1(0).word, s1.map(_.count).sum))
  }

  def run(in: Source[LineModel]) = {
    in.splitText().sumByWord()
  }

  def main(args: Array[String]) {
    val list = List("Hello World", "Hello Asakusa", "Hello Hadoop")
    val r = run(Source(list.map { LineModel(_) }: _*))
    println(r)
  }
}
