package afwhs.a0001

import jp.hishidama.afwhs._

object Sample2Score2 {

  implicit def implicitTenModel(in: Source[TenModel]) = new {
    def splitByKamoku() = in.cogroup("split", "", Result[KamokuModel]("out")) {
      (s, r) =>
        s.foreach { ten =>
          r.add(createKamoku(ten, 0, ten.suugaku))
          r.add(createKamoku(ten, 1, ten.kokugo))
          r.add(createKamoku(ten, 2, ten.rika))
          r.add(createKamoku(ten, 3, ten.shakai))
          r.add(createKamoku(ten, 4, ten.eigo))
          r.add(createKamoku(ten, 5, ten.suugaku + ten.kokugo + ten.rika + ten.shakai + ten.eigo))
        }
    }
  }

  implicit def implicitKamokuModel(in: Source[KamokuModel]) = new {
    def calcTotal() = in.summarize[KamokuTotal]("total", SAny("kid"), SSum("ten"), SCount("sid" -> "count"))

    def calcSigma(average: Source[AverageModel]) = in.cogroup("sigma", "kid", "kid" -> average, Result[SigmaModel]("out")) {
      (list, aveList, r) =>
        val am = aveList.head
        val sum = list.map(km => math.pow(km.ten - am.average, 2)).sum
        r.add(SigmaModel(am.kid, am.average, math.sqrt(sum / am.count)))
    }

    def calcScore(sigma: Source[SigmaModel]) = in.cogroup("score", "kid", "kid" -> sigma, Result[ScoreModel]("out")) {
      (list, sigmaList, r) =>
        val sm = sigmaList.head
        list.foreach { km =>
          r.add(ScoreModel(
            km.sid, km.sname,
            Ȗږ(km.kid),
            km.ten,
            sm.average,
            (km.ten - sm.average) * 10 / sm.sigma + 50))
        }
    }
  }

  implicit def implicitKamokuTotal(total: Source[KamokuTotal]) = new {
    def calcAverage() = total.convert("average") {
      s =>
        AverageModel(s.kid, s.ten, s.count, s.ten.toDouble / s.count)
    }._1
  }

  def run(l_: Source[TenModel]) = {
    val Ȗڕʌl_ = l_.splitByKamoku()
    val Ȗڕʕϓ_ = Ȗڕʌl_.calcTotal().calcAverage()
    val ȖڕʕW΍ = Ȗڕʌl_.calcSigma(Ȗڕʕϓ_)
    val Ȗڕʌl΍l = Ȗڕʌl_.calcScore(ȖڕʕW΍)
    Ȗڕʌl΍l
  }

  def createKamoku(tm: TenModel, kid: Int, ten: Int) =
    KamokuModel(tm.sid, tm.sname, kid, ten)

  val Ȗږ = Array("w", "", "", "Љ", "p", "v")

  def main(args: Array[String]) {
    val in = Source(
      TenModel("101", "V", 100, 100, 100, 100, 100),
      TenModel("201", "C", 5, 30, 10, 20, 15),
      TenModel("102", "Ђ", 90, 85, 80, 50, 10),
      TenModel("202", "hoge", 10, 30, 25, 45, 20),
      TenModel("103", "foo", 60, 60, 60, 60, 25),
      TenModel("204", "xxx", 80, 77, 90, 40, 44),
      TenModel("205", "yyy", 65, 90, 55, 80, 65),
      TenModel("104", "zzz", 40, 60, 60, 70, 20))
    val r = run(in)
    println(r)
  }
}